/*
 *
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _PROTOTYPE_H_
#define _PROTOTYPE_H_

void xexit (const int error);
void decode_getopt (const int argc, char **argv);
char* xstrdup (const char *original);
void* xmalloc (const int size);
int xstrtol (const char *str, int *error);
void xfree (void *ptr);
int check_rang_ip (void);
int parse_tab_ip (const char *ip, int *tab);
void config_scanner (void);
void scanner (void);
int incremente_ip (char *ip);
void start_child (int id);
void RIP_child (int id, int forced);
void write_file (const char *ip);

/* prototype signal function */
void signal_init (void);
void signal_handler (int status);
/**/

/* prototype print function */
void print_help (void);
void print_verbose_argv (void);
void print_started (void);
void print_static (void);
void print_static_current (void);
void print_version (void);
/**/

/* prototype socket function */
struct socket_s* create_socket ();
int create_socket_stream (void);
int connect_socket(struct socket_s *sock);
int xsend (const char *str, int size, int socket);
int xrecv (char *str, size_t size, int socket);
int block_or_unblock_socket (int socket);
int get_socket_mode (int socket);
void free_socket (struct socket_s *socket);
/**/

/* prototype of shared memory function */
key_t create_key (void);
int create_shared_memory (key_t key, int size);
char* attach_shared_memory (int id);
void detach_shared_memory (char *memory);
void shared_memory_destroy (int id);
/**/

/* prototype pile function */
void push_pile (const char *ip);
void free_pile (void);
/**/

/* prototype ftp function */
int test_ftp_access (void);
int identify_ftp (int socket);
int logout_suession_ftp (int socket);
/**/

/* prototype pop3 function */
int test_pop3_access (void);
int identify_pop3 (int socket);
void logout_suession_pop3 (int socket);
/**/

/* prototype mysql function */
int test_mysql_access (void);
/**/

/* prototype imap function */
int test_imap_access (void);
int identify_imap(int socket);
void logout_suession_imap (int socket);
/**/

/* prototype all proto function */
int check_answer_proto (const char *answer, const char *original_answer);

#endif /* _PROTOTYPE_H_ */