/*
 *
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _TYPEDEF_H_
#define _TYPEDEF_H_

#include <arpa/inet.h>
#include "config.h"

enum ERR_PROG
  {
    ERR_NO_ARGV,
    ERR_PORT,
    ERR_UNKNOW_ARGV,
    ERR_STRTOL,
    ERR_STRDUP,
    ERR_ALLOC_MEM,
    ERR_IP_UNKNOW,
    ERR_IP_INVALID,
    ERR_PROTO_UNKNOW,
    ERR_CREATE_KEY,
    ERR_CREATE_SHARED_MEM,
    ERR_DESTOY_SHARED_MEM,
    ERR_DETACH_MEM
  };

enum ERR_AUTHEN
  {
    ERR_ACC = -4,
    ERR_LOGIN = -2,
    ERR_PASSWD = -3,
    ERR_SOCKET = -1
  };

struct proto_s
  {
    char  *name,
          *login,
          *passwd;
    int port;
  };

struct stat_s
  {
    int     n_ip,
            n_open,
            n_found;
    time_t  start,
            stop;
  };

struct pile_s
  {
    char ip[IPv4_SIZE];
    struct pile_s *next;
  };

struct socket_s
  {
    int socket;
    struct sockaddr_in to;
  };

struct opt_s
  {
    char  login[SIZE_AUTHEN],
          passwd[SIZE_AUTHEN],
          ip_current[IPv4_SIZE],
          ip_end[IPv4_SIZE],
          proto[LEN_PROTO];
    int   log,
          port,
          verbose,
          timeout,
          n_proc;
  };

#endif /* _TYPEDEF_H_ */