/*
 *
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include "typedef.h"
#include "global.h"

void
xexit (const int error)
{
  if (error == ERR_NO_ARGV)
    {
      fprintf(stderr, "Argument not specified!\n");
      print_help();
    }
  else if (error == ERR_UNKNOW_ARGV)
    {
      fprintf(stderr, "Argument unknow.\n");
      print_help();
    }
  else if (error == ERR_PORT)
    {
      fprintf(stderr, "Port invalid!\n");
      print_help();
    }
  else if (error == ERR_STRDUP)
    fprintf(stderr, "[strdup()] error copy.\n");
  else if (error == ERR_ALLOC_MEM)
    fprintf(stderr, "[malloc] virtual memory exhausted.\n");
  else if (error == ERR_IP_UNKNOW)
    fprintf(stderr, "IP start or end not specified!\n");
  else if (error == ERR_IP_INVALID)
    fprintf(stderr, "IP invalid format!\n");
  else if (error == ERR_PROTO_UNKNOW)
    fprintf(stderr, "portocol unknow!\n");
  else if (error == ERR_CREATE_KEY && debug)
    perror("[ftok()] ");
  else if (error == ERR_CREATE_SHARED_MEM && debug)
    perror("[shmget()] ");
  else if (error == ERR_DESTOY_SHARED_MEM && debug)
    perror("[shmctl()] ");
  else if (error == ERR_DETACH_MEM && debug)
    perror("[shmdt()] ");

  p_opt = NULL;
  free_pile();
  exit(EXIT_FAILURE);
}