/*
 *
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <string.h>
#include <stdio.h>

#include "typedef.h"
#include "global.h"

int
test_ftp_access (void)
{
  int ret;
  struct socket_s *socket = NULL;

  socket = create_socket();
  if (!socket)
    return -1;

  ret = connect_socket(socket);
  if (ret != -1 )
    {
      ret = identify_ftp(socket->socket);
      logout_suession_ftp(socket->socket);
      if (ret)
        ret = 2;
    }

  free_socket(socket);
  return ret;
}

int
identify_ftp (int socket)
{
  char ftp[500] = {0};
  size_t size;
  int ret;

  size = sizeof(ftp)-1;
  ret = xrecv(ftp, size, socket);
  if (ret <= 0)
    return ERR_SOCKET;

  ret = check_answer_proto(ftp, FTP_ACCEUIL);
  if (ret == -1)
    return ERR_ACC;

  memset(ftp, 0, ret);
  snprintf(ftp, size, "USER %s\r\n", p_opt->login);
  ret = xsend(ftp, strlen(ftp), socket);
  if (ret == -1)
    return ERR_SOCKET;

  ret = xrecv(ftp, size, socket);
  if (ret < 1)
    return ERR_SOCKET;

  ret = check_answer_proto(ftp, FTP_ACCEPT_LOGIN);
  if (ret == -1)
    return ERR_LOGIN;


  memset(ftp, 0, ret);
  snprintf(ftp, size, "PASS %s\r\n", p_opt->passwd);
  ret = xsend(ftp, strlen(ftp), socket);
  if (ret == -1)
    return ERR_SOCKET;

  ret = xrecv(ftp, size, socket);
  if (ret < 1)
    return ERR_SOCKET;

  ret = check_answer_proto(ftp, FTP_ACCEPT_PASSWD);
  if (ret == -1)
    return ERR_PASSWD;

  return 0;
}

int
logout_suession_ftp (int socket)
{
  int ret;

  ret = xsend(QUIT_FTP, strlen(QUIT_FTP), socket);
  if (ret == -1 && debug)
    fprintf(stderr, "quit server FTP error\n");

  return ret;
}