/*
 *
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <time.h>

#include "global.h"
#include "typedef.h"

void
print_help (void)
{
  printf("Help menu :\n"
  "\r\t-h\r\t\t : print help menu\n"
  "\r\t-b\r\t\t : ip start\n"
  "\r\t-e\r\t\t : ip end\n"
  "\r\t-p\r\t\t : port (default 21)\n"
  "\r\t-t\r\t\t : timeout (default 3s)\n"
  "\r\t-n\r\t\t : proc numbers (default 100)\n"
  "\r\t-l\r\t\t : login (default anonymous)\n"
  "\r\t-a\r\t\t : passwd (default anonymous)\n"
  "\r\t-v\r\t\t : verbose mode\n"
  "\r\t-d\r\t\t : debug mode\n"
  "\r\t-f\r\t\t : write result in file (NULLSearch.txt)\n");
}

void
print_verbose_argv (void)
{
  printf("port :%d\nlogin :%s\npasswd :%s\nip start :%s\n"
         "ip end :%s\nn proc :%d\ntimeout :%d\nlog :%d\nproto :%s\n",
          p_opt->port, p_opt->login, p_opt->passwd, p_opt->ip_current,
          p_opt->ip_end, p_opt->n_proc, p_opt->timeout, p_opt->log, p_opt->proto);
}

void
print_started (void)
{
  printf("... scan started ...\n"
        "... CTRL+C to stoped\n"
        "... CTRL+\\ for info\n");
}

void
print_static (void)
{
  struct pile_s *p_pile = pile;

  if (pile)
    {
      printf("\rIP\r\t\tPORT\n");
      while (p_pile)
        {
          printf("%s\r\t\t%d\n", p_pile->ip, p_opt->port);
          p_pile = p_pile->next;
        }
    }
  else
    printf("Not ip found.\n");

  printf("STATISTIQUE : \n- scanned : %d\n- open port : %d\n- ip accept null session : %d\n- in : %d second(s)\n",
         stt.n_ip, stt.n_open, stt.n_found, (int)(stt.stop - stt.start));
}

void
print_static_current (void)
{
  stt.stop = time(NULL);
  printf("ip scanned: %d | open port: %d | nb found: %d | current ip: %s | time: %lds\n",
         stt.n_ip, stt.n_open, stt.n_found, ip_scanned, (stt.stop-stt.start));
}

void
print_version (void)
{
  printf("\r\n\tNullSearchAccess"
        "\r\n\tversion 0.1 Beta\n\n");
}